//   "i2c_new", , 6-2007
#include <avr/io.h> // -
#include <util/delay.h> // 
#define ATMEGA16 1 //1=ATmega16, 0= ATmega16
#define ATMEGA8  0 //1=ATmega8,  0= ATmega8
#if ATMEGA16 //    ATmega16
  #define DDRX DDRD //  DDRD
		#define PORTX PORTD //  PORTD
		#define PINX PIND //  PIND
		#define SCL PD3 //    PD3  I2C
  #define SDA PD4 //    PD4  I2C
#else //      ATmega8
  #define DDRX DDRB //  DDRB
		#define PORTX PORTB //  PORTB
		#define PINX PINB //  PINB
		#define SCL PB0 //    PB0  I2C
  #define SDA PB1 //    PB1  I2C
#endif //  "#if-#else"
//---------------  --------------
void pause(void) //   
{ _delay_us(10); //  10  ()
  return; //   
} //  "pause"
//-------------    I2C-------------
void i2start(void) // START  I2C
{ DDRX &= ~_BV(SDA) & ~_BV(SCL); //SDA, SCL - 
  PORTX &= ~_BV(SDA) & ~_BV(SCL); //" "
		pause(); //  .1  SCL  SDA
  DDRX |= _BV(SDA); // .0  SDA
  pause(); //  .0  SDA  .1  SCL
  DDRX |= _BV(SCL); // .0  SCL
  pause(); //  .0  SCL  SDA
  return; //   
} //  "i2start"
//-----------     i2c----------
void i2write(unsigned char bw) // WRITE  I2C
{ unsigned char k, m; // 
  for (k=0; k < 8; k++) // 8   
  { m = 0x01 & (bw >> (7-k)); //  
    if (m == 0) DDRX |= _BV(SDA); // .0 SDA
	   else DDRX &= ~_BV(SDA); //  .1 SDA
    pause(); //   SCL
    DDRX &= ~_BV(SCL); pause(); // .1 SCL
    DDRX |= _BV(SCL); pause(); //  .0 SCL
  } //    
  return; //   
} //  "i2write"
//---------   ---------
unsigned char i2ack(void) // ACK  I2C
{ unsigned char check=0; //   
  DDRX &= ~_BV(SDA); pause(); //  .1  SDA
  DDRX &= ~_BV(SCL); pause(); // .1  SCL
  if (bit_is_set(PINX,SDA)) check++; // 
  DDRX |= _BV(SCL); pause(); //  .0  SCL
  return (check); // "0" (), "1" ()
} //  "i2ack"
//--------     I2C--------
void i2stop(void) // STOP  I2C
{ DDRX |= _BV(SDA); pause(); //  .0 SDA, SCL
  DDRX &= ~_BV(SCL); // .1  SCL
		pause(); //  .0  SDA  .1  SCL
  DDRX &= ~_BV(SDA); pause(); //  .1 SDA, SCL
  return; //   
} //  "i2stop"
